#include "StdAfx.h"
#include "Shoot.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int System::NUM = 1000;
System* System::m_pThis = NULL;

System::System(){
	m_pObjects = new MoveObject*[NUM];
	for ( int i = 0 ; i < NUM ; i++ ) {
		m_pObjects[i] = NULL;
	}
}
//fXgN^
System::~System() {
	if ( m_pObjects ) {
		for ( int i = 0 ; i < NUM ; i++ ) {
			if ( m_pObjects[i] != NULL ) {
				delete m_pObjects[i];
			}
		}
		delete [] m_pObjects;
	}
}

System* System::GetInstance() {
	if ( m_pThis == NULL ) {
		m_pThis = new System;
		m_pThis->Add( new MyShip() );
	}
	return m_pThis;
}
//CX^Xj
void System::DeleteInstance(){
	if ( m_pThis != NULL ) {
		delete m_pThis;
		m_pThis = NULL;
	}
}
//IuWFNgǉ
bool System::Add( MoveObject* p ) {
	for ( int i = 0 ; i < NUM ; i++ ) {
		if ( m_pObjects[i] == NULL ) {
			m_pObjects[i] = p;
			return true;//ǉ
		}
	}
	delete p;
	return false;
}
//IuWFNg폜
void System::Delete( MoveObject* p ){
	for ( int i = 0 ; i < NUM ; i++ ) {
		if ( m_pObjects[i] == p ) {
			m_pObjects[i] = NULL;
			delete p;
			return;
		}
	}
	TRACE("Not Found!\n");
}
//`
void System::Draw( CBaseView* pView,CDC* pDC ) {
	//g
	pView->MoveTo(pDC, 0,0); 
	pView->LineTo(pDC, 640,0);
	pView->LineTo(pDC, 640,480);
	pView->LineTo(pDC, 0,480);
	pView->LineTo(pDC, 0,0);
	//SIuWFNg`
	for ( int i = 0; i < NUM ; i++ ) {
		if ( m_pObjects[i] != NULL ) {
			m_pObjects[i]->Draw( pView, pDC );
		}
	}
}
void System::Move( double dTick ) {
	//G
	if ( System::Rand() < 0.1 ) {
		Add( new EnemyA( CVector2d( 640 * System::Rand(), 0 ) ) );
	}
	//SIuWFNgړ
	for ( int i = 0; i < NUM ; i++ ) {
		if ( m_pObjects[i] != NULL ) {
			m_pObjects[i]->Move( dTick );
		}
	}
}
//Vbv̈ʒu̎擾
CVector2d System::GetMyShipPos()
{
	if ( m_pObjects[0] != NULL ) {
		return m_pObjects[0]->m_vPos;
	} else {
		return CVector2d(320,240);
	}
}

void System::Hit() {
}

//̃NX(ۃNXj
MoveObject::MoveObject() {//RXgN^
	m_vVelo = CVector2d(0.0, 0.0);
}
void MoveObject::Move( double dTick ) {//ړ
	m_vPos += m_vVelo * dTick;
}
bool MoveObject::Hit( CVector2d vLeftTop,CVector2d vRightBottom ){
	return false;
}

//[U[NXĩ~TCj
Leaser::Leaser( CVector2d p, CVector2d v ) {
	m_vPos = p;
	m_vVelo = CVector2d( v.GetX(), -900 );
}
void Leaser::Move( double dTick ) {
	m_vPos += m_vVelo * dTick;
	if ( m_vPos.GetY() < 0 ) {
		System::GetInstance()->Delete( this );
	}
}
void Leaser::Draw( CBaseView* pView, CDC* pDC ) {
	//c`
	pView->MoveTo(pDC, m_vPos + CVector2d(0,-25));
	pView->LineTo(pDC, m_vPos + CVector2d(0, 25));
}

//VbvijNX
MyShip::MyShip() {
	m_vPos = CVector2d(320,400);
}
void MyShip::Move( double dTick ) {
	//ړ
	CVector2d a(0,0);
	if ( GetAsyncKeyState( VK_LEFT ) < 0 ) a += CVector2d(-1,0);
	if ( GetAsyncKeyState( VK_RIGHT ) < 0 ) a += CVector2d(1,0);
	if ( GetAsyncKeyState( VK_UP ) < 0 ) a += CVector2d(0,-1);
	if ( GetAsyncKeyState( VK_DOWN ) < 0 ) a += CVector2d(0,1);
	if ( a.GetLength() > 0 ) {//L[Ă
		m_vVelo = a * 300;
	}
	m_vPos += m_vVelo * dTick;
	m_vVelo *= 0.7;//CR
	//~TC
	if ( GetAsyncKeyState( VK_SHIFT ) < 0 ) {
		System::GetInstance()->Add( new Leaser(m_vPos, m_vVelo) );
	}
}
void MyShip::Draw( CBaseView* pView, CDC* pDC ) {
	//Op``
	pView->MoveTo( pDC, m_vPos + CVector2d(0,-30) );
	pView->LineTo( pDC, m_vPos + CVector2d(-20,15) );
	pView->LineTo( pDC, m_vPos + CVector2d( 20,15) );
	pView->LineTo( pDC, m_vPos + CVector2d(0,-30) );
}

//GA
EnemyA::EnemyA( CVector2d p ) {
	m_vPos = p;
	m_vVelo = CVector2d( 10 * System::Rand()-5, 100.0 + System::Rand() * 20.0 );
	m_dwBorn = 0;
}
void EnemyA::Move( double dTick ) {
	System* pSys = System::GetInstance();
	double t = (double)(GetTickCount() - m_dwBorn)/1000.0;
	m_vVelo += CVector2d( 10 * sin( t * 5.0 ), 0 );
	m_vPos += m_vVelo * dTick;
	if ( m_vPos.GetY() > 480 ) {//ʂo
		pSys->Delete(this);
	}
	if ( System::Rand() < 0.05 ) {//~TC
		pSys->Add( new MissileA( m_vPos, pSys->GetMyShipPos() ) );
	}
}
void EnemyA::Draw( CBaseView* pView, CDC* pDC ) {
	//Op``
	pView->MoveTo( pDC, m_vPos + CVector2d(0,20) );
	pView->LineTo( pDC, m_vPos + CVector2d(-20,-15) );
	pView->LineTo( pDC, m_vPos + CVector2d( 20,-15) );
	pView->LineTo( pDC, m_vPos + CVector2d(0,20) );
}


//~TCANX
MissileA::MissileA( CVector2d from, CVector2d to ){
	m_vPos = from;
	m_vVelo = to - from;
	m_vVelo.Normalize();
	m_vVelo *= 200;//~TC̑x
}
void MissileA::Move( double dTick )
{
	m_vPos += m_vVelo * dTick;
	if ( m_vPos.GetX() < 0 ||
		 m_vPos.GetX() > 640 || 
		 m_vPos.GetY() < 0 ||
		 m_vPos.GetY() > 480 ) {
		System::GetInstance()->Delete(this);
	}
}

void MissileA::Draw( CBaseView* pView, CDC* pDC )
{
	pView->Circle( pDC, m_vPos, 5 );
}

